
                   
define([
    'fraudCommons/util/DateUtil',
    'dojo/_base/array'
], function(dateUtil, array) {
    return {
        
        generateParameters: function(d_selectedTab, formId, groups, concatDelimiter) {
            var delimiter = '|';
            if(!concatDelimiter) {
                console.warn('DynamicUIUtil.generateParameters: concatDelimiter was undefined, assuming pipe character');
            }
            else {
                delimiter = concatDelimiter;
            }

            var parameters = [];

            array.forEach(groups, function(group, index) {
                var parameter = {
                    queryType: group.getParent().get('data-form-id'),
                    queryParameter: group.get('data-group-id')
                };

                if(parameter.queryType !== d_selectedTab.get('data-form-id')) {
                    return; 
                }

                var children = group.getChildren();

                array.forEach(children, function(child, childIndex) {
                    array.forEach(child.getChildren(), function(childElement, childElementIndex) {
                        if(childElement.declaredClass === 'dijit.form.TextBox' || childElement.declaredClass === 'dijit.form.SimpleTextarea') {
                            if(parameter.queryValue) {
                                parameter.queryValue += delimiter + childElement.value;
                            }
                            else {
                                parameter.queryValue = childElement.value;
                            }
                        }
                        else if(childElement.declaredClass === 'sas.sna.model.widgets.DateTextBox' || childElement.declaredClass === 'dijit.form.DateTextBox') {

                            if (childElement.value !== null) {
                                var time = childElement.value.getTime();
                            } else { 
                                var time = undefined;
                            }

                            var actualValue = '';

                            if(!isNaN(time)) { 
                                actualValue = dateUtil.toSasDate(childElement.value);
                            }

                            if(parameter.queryValue) {
                                parameter.queryValue += delimiter + actualValue;
                            }
                            else {
                                parameter.queryValue = actualValue;
                            }
                        }
                        else if (childElement.declaredClass === 'dijit.form.RadioButton' || childElement.declaredClass === 'dijit.form.CheckBox') {
                            if(childElement.checked) {
                                if(parameter.queryValue) {
                                    parameter.queryValue += delimiter + childElement.value;
                                }
                                else {
                                    parameter.queryValue = childElement.value;
                                }
                            }
                        }
                        else if (childElement.declaredClass === 'sas.sna.model.widgets.PreferencesMultiSelect') {
                            var element = childElement.getChildren();

                            array.forEach(element, function(value) {
                                if(value.selected) {
                                    if(parameter.queryValue) {
                                        parameter.queryValue += delimiter + value.value;
                                    }
                                    else {
                                        parameter.queryValue = value.value;
                                    }
                                }
                            });

                            
                        }
                        else if (childElement.declaredClass === 'dijit.form.Select') {
                            parameter.queryValue = childElement.value;
                        }
                        else {
                            console.warn('didnt recognize ' + childElement.declaredClass, childElement);
                            parameter.queryValue = childElement.value;
                        }
                    });
                });

                if(typeof(parameter.queryValue) === 'undefined') {
                    parameter.queryValue = '';
                }

                parameters.push(parameter);
            });

            return {
                queryParams: parameters
            };
        }
    };
});

               